
/*  A Bison parser, made from zparser.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	T_A	257
#define	T_NS	258
#define	T_MX	259
#define	T_TXT	260
#define	T_CNAME	261
#define	T_AAAA	262
#define	T_PTR	263
#define	T_NXT	264
#define	T_KEY	265
#define	T_SOA	266
#define	T_SIG	267
#define	T_SRV	268
#define	T_CERT	269
#define	T_LOC	270
#define	T_MD	271
#define	T_MF	272
#define	T_MB	273
#define	T_MG	274
#define	T_MR	275
#define	T_NULL	276
#define	T_WKS	277
#define	T_HINFO	278
#define	T_MINFO	279
#define	T_RP	280
#define	T_AFSDB	281
#define	T_X25	282
#define	T_ISDN	283
#define	T_RT	284
#define	T_NSAP	285
#define	T_NSAP_PTR	286
#define	T_PX	287
#define	T_GPOS	288
#define	T_EID	289
#define	T_NIMLOC	290
#define	T_ATMA	291
#define	T_NAPTR	292
#define	T_KX	293
#define	T_A6	294
#define	T_DNAME	295
#define	T_SINK	296
#define	T_OPT	297
#define	T_APL	298
#define	T_UINFO	299
#define	T_UID	300
#define	T_GID	301
#define	T_UNSPEC	302
#define	T_TKEY	303
#define	T_TSIG	304
#define	T_IXFR	305
#define	T_AXFR	306
#define	T_MAILB	307
#define	T_MAILA	308
#define	T_DS	309
#define	T_SSHFP	310
#define	T_RRSIG	311
#define	T_NSEC	312
#define	T_DNSKEY	313
#define	DIR_TTL	314
#define	DIR_ORIG	315
#define	NL	316
#define	ORIGIN	317
#define	SP	318
#define	STR	319
#define	PREV	320
#define	TTL	321
#define	T_IN	322
#define	T_CH	323
#define	T_HS	324
#define	URR	325
#define	T_UTYPE	326

#line 1 "zparser.y"

/*
 * zyparser.y -- yacc grammar for (DNS) zone files
 *
 * Copyright (c) 2001-2004, NLnet Labs. All rights reserved.
 *
 * See LICENSE for the license
 */

#include <config.h>
	
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
	
#include "dname.h"
#include "namedb.h"
#include "zonec.h"

/* these need to be global, otherwise they cannot be used inside yacc */
zparser_type *parser;

#ifdef __cplusplus
extern "C"
#endif /* __cplusplus */
int yywrap(void);

/* this hold the nxt bits */
static uint8_t nxtbits[16];

/* 256 windows of 256 bits (32 bytes) */
/* still need to reset the bastard somewhere */
static uint8_t nsecbits[NSEC_WINDOW_COUNT][NSEC_WINDOW_BITS_SIZE];


#line 36 "zparser.y"
typedef union {
	domain_type      *domain;
	const dname_type *dname;
	struct lex_data   data;
	uint32_t          ttl;
	uint16_t          klass;
	uint16_t          type;
	uint16_t         *unknown;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		457
#define	YYFLAG		-32768
#define	YYNTBASE	74

#define YYTRANSLATE(x) ((unsigned)(x) <= 326 ? yytranslate[x] : 128)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,    73,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     6,     9,    12,    15,    17,    20,    22,
    25,    27,    30,    34,    38,    42,    46,    49,    53,    55,
    57,    60,    62,    64,    66,    67,    70,    73,    78,    83,
    85,    87,    89,    92,    94,    96,   100,   102,   106,   108,
   110,   114,   118,   120,   124,   126,   130,   132,   136,   138,
   142,   144,   148,   152,   156,   160,   164,   168,   172,   176,
   180,   184,   188,   192,   196,   200,   204,   208,   212,   216,
   220,   224,   228,   232,   236,   240,   244,   248,   252,   256,
   260,   264,   268,   272,   276,   280,   284,   288,   292,   296,
   300,   304,   308,   312,   316,   320,   324,   328,   332,   336,
   340,   344,   348,   352,   356,   360,   364,   368,   372,   376,
   380,   384,   388,   392,   396,   400,   404,   407,   411,   415,
   419,   423,   427,   431,   435,   439,   443,   447,   451,   455,
   459,   463,   466,   469,   472,   475,   490,   493,   500,   503,
   508,   511,   516,   521,   524,   527,   530,   535,   538,   543,
   546,   549,   552,   555,   560,   563,   568,   571,   574,   577,
   584,   587,   590,   593,   596,   599,   604,   607,   616,   619,
   632,   635,   640,   643,   652,   655,   658,   661,   663,   667,
   676,   679,   686,   689,   708,   711,   716,   719,   728,   731,
   738,   743
};

static const short yyrhs[] = {    -1,
    74,    75,     0,    62,     0,    76,    62,     0,    60,    78,
     0,    61,    79,     0,    80,     0,     1,    62,     0,    64,
     0,    76,    64,     0,    62,     0,    76,    62,     0,    64,
    65,    77,     0,    64,    87,    77,     0,    64,    89,    77,
     0,    63,    76,    83,     0,    66,    83,     0,    86,    76,
    83,     0,    67,     0,    68,     0,    85,    97,     0,    82,
     0,    69,     0,    70,     0,     0,    84,    76,     0,    81,
    76,     0,    81,    76,    84,    76,     0,    84,    76,    81,
    76,     0,    87,     0,    89,     0,    73,     0,    89,    73,
     0,    65,     0,    88,     0,    89,    73,    88,     0,    65,
     0,    90,    76,    65,     0,    65,     0,    73,     0,    91,
    76,    65,     0,    91,    73,    65,     0,    65,     0,    92,
    76,    65,     0,    65,     0,    93,    76,    65,     0,    65,
     0,    94,    76,    65,     0,    65,     0,    95,    73,    65,
     0,    65,     0,    96,    73,    65,     0,     3,    76,    98,
     0,     3,    76,   127,     0,     4,    76,    99,     0,     4,
    76,   127,     0,    17,    76,    99,     0,    17,    76,   127,
     0,    18,    76,    99,     0,    18,    76,   127,     0,     7,
    76,    99,     0,     7,    76,   127,     0,    12,    76,   100,
     0,    12,    76,   127,     0,    19,    76,    99,     0,    19,
    76,   127,     0,    20,    76,    99,     0,    20,    76,   127,
     0,    21,    76,    99,     0,    21,    76,   127,     0,    23,
    76,   101,     0,    23,    76,   127,     0,     9,    76,    99,
     0,     9,    76,   127,     0,    24,    76,   102,     0,    24,
    76,   127,     0,    25,    76,   103,     0,    25,    76,   127,
     0,     5,    76,   104,     0,     5,    76,   127,     0,     6,
    76,   105,     0,     6,    76,   127,     0,    26,    76,   106,
     0,    26,    76,   127,     0,    27,    76,   107,     0,    27,
    76,   127,     0,    28,    76,   108,     0,    28,    76,   127,
     0,    29,    76,   109,     0,    29,    76,   127,     0,    30,
    76,   110,     0,    30,    76,   127,     0,    31,    76,   111,
     0,    31,    76,   127,     0,    13,    76,   124,     0,    13,
    76,   127,     0,    11,    76,   126,     0,    11,    76,   127,
     0,    33,    76,   112,     0,    33,    76,   127,     0,     8,
    76,   113,     0,     8,    76,   127,     0,    16,    76,   114,
     0,    16,    76,   127,     0,    10,    76,   115,     0,    10,
    76,   127,     0,    14,    76,   116,     0,    14,    76,   127,
     0,    38,    76,   117,     0,    38,    76,   127,     0,    39,
    76,   118,     0,    39,    76,   127,     0,    15,    76,   119,
     0,    15,    76,   127,     0,    41,    76,    99,     0,    41,
    76,   127,     0,    44,    77,     0,    44,    76,   120,     0,
    44,    76,   127,     0,    55,    76,   122,     0,    55,    76,
   127,     0,    56,    76,   123,     0,    56,    76,   127,     0,
    57,    76,   124,     0,    57,    76,   127,     0,    58,    76,
   125,     0,    58,    76,   127,     0,    59,    76,   126,     0,
    59,    76,   127,     0,    72,    76,   127,     0,    65,     1,
    62,     0,    96,    77,     0,     1,    62,     0,    86,    77,
     0,     1,    62,     0,    86,    76,    86,    76,    65,    76,
    65,    76,    65,    76,    65,    76,    65,    77,     0,     1,
    62,     0,    96,    76,    65,    76,    91,    77,     0,     1,
    62,     0,    65,    76,    65,    77,     0,     1,    62,     0,
    86,    76,    86,    77,     0,    65,    76,    86,    77,     0,
     1,    62,     0,    90,    77,     0,     1,    62,     0,    86,
    76,    86,    77,     0,     1,    62,     0,    65,    76,    86,
    77,     0,     1,    62,     0,    65,    77,     0,     1,    62,
     0,    65,    77,     0,    65,    76,    65,    77,     0,     1,
    62,     0,    65,    76,    86,    77,     0,     1,    62,     0,
    95,    77,     0,     1,    62,     0,    65,    76,    86,    76,
    86,    77,     0,     1,    62,     0,    65,    77,     0,     1,
    62,     0,    91,    77,     0,     1,    62,     0,    86,    76,
    92,    77,     0,     1,    62,     0,    65,    76,    65,    76,
    65,    76,    86,    77,     0,     1,    62,     0,    65,    76,
    65,    76,    65,    76,    65,    76,    65,    76,    86,    77,
     0,     1,    62,     0,    65,    76,    86,    77,     0,     1,
    62,     0,    65,    76,    65,    76,    65,    76,    94,    77,
     0,     1,    62,     0,   121,    77,     0,     1,    62,     0,
    96,     0,   121,    76,    96,     0,    65,    76,    65,    76,
    65,    76,    94,    77,     0,     1,    62,     0,    65,    76,
    65,    76,    94,    77,     0,     1,    62,     0,    65,    76,
    65,    76,    65,    76,    65,    76,    65,    76,    65,    76,
    65,    76,    86,    76,    94,    77,     0,     1,    62,     0,
    86,    76,    93,    77,     0,     1,    62,     0,    65,    76,
    65,    76,    65,    76,    94,    77,     0,     1,    62,     0,
    71,    76,    65,    76,    94,    77,     0,    71,    76,    65,
    77,     0,    71,     1,    62,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    73,    74,    77,    78,    79,    80,    81,   107,   114,   115,
   118,   119,   122,   134,   142,   148,   153,   159,   169,   180,
   187,   193,   194,   195,   198,   203,   207,   211,   212,   215,
   216,   231,   235,   245,   256,   257,   270,   274,   281,   282,
   287,   296,   308,   317,   328,   337,   352,   353,   369,   370,
   385,   386,   400,   406,   407,   408,   409,   410,   415,   416,
   422,   423,   424,   425,   426,   427,   433,   434,   435,   436,
   438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
   448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
   458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
   468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
   478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
   488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
   498,   510,   514,   518,   523,   527,   542,   546,   558,   562,
   567,   571,   579,   584,   588,   589,   594,   599,   604,   609,
   614,   618,   623,   627,   632,   637,   642,   647,   656,   661,
   667,   671,   675,   679,   683,   687,   693,   697,   704,   709,
   718,   723,   728,   733,   740,   745,   746,   750,   754,   760,
   767,   771,   777,   781,   793,   797,   803,   808,   815,   819,
   825,   829
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","T_A","T_NS",
"T_MX","T_TXT","T_CNAME","T_AAAA","T_PTR","T_NXT","T_KEY","T_SOA","T_SIG","T_SRV",
"T_CERT","T_LOC","T_MD","T_MF","T_MB","T_MG","T_MR","T_NULL","T_WKS","T_HINFO",
"T_MINFO","T_RP","T_AFSDB","T_X25","T_ISDN","T_RT","T_NSAP","T_NSAP_PTR","T_PX",
"T_GPOS","T_EID","T_NIMLOC","T_ATMA","T_NAPTR","T_KX","T_A6","T_DNAME","T_SINK",
"T_OPT","T_APL","T_UINFO","T_UID","T_GID","T_UNSPEC","T_TKEY","T_TSIG","T_IXFR",
"T_AXFR","T_MAILB","T_MAILA","T_DS","T_SSHFP","T_RRSIG","T_NSEC","T_DNSKEY",
"DIR_TTL","DIR_ORIG","NL","ORIGIN","SP","STR","PREV","TTL","T_IN","T_CH","T_HS",
"URR","T_UTYPE","'.'","lines","line","sp","trail","dir_ttl","dir_orig","rr",
"ttl","in","rrrest","class","classttl","dname","abs_dname","label","rel_dname",
"str_seq","concatenated_str_seq","nxt_seq","nsec_seq","str_sp_seq","str_dot_seq",
"dotted_str","rtype","rdata_a","rdata_domain_name","rdata_soa","rdata_wks","rdata_hinfo",
"rdata_minfo","rdata_mx","rdata_txt","rdata_rp","rdata_afsdb","rdata_x25","rdata_isdn",
"rdata_rt","rdata_nsap","rdata_px","rdata_aaaa","rdata_loc","rdata_nxt","rdata_srv",
"rdata_naptr","rdata_kx","rdata_cert","rdata_apl","rdata_apl_seq","rdata_ds",
"rdata_sshfp","rdata_rrsig","rdata_nsec","rdata_dnskey","rdata_unknown", NULL
};
#endif

static const short yyr1[] = {     0,
    74,    74,    75,    75,    75,    75,    75,    75,    76,    76,
    77,    77,    78,    79,    79,    80,    80,    80,    81,    82,
    83,    84,    84,    84,    85,    85,    85,    85,    85,    86,
    86,    87,    87,    88,    89,    89,    90,    90,    91,    91,
    91,    91,    92,    92,    93,    93,    94,    94,    95,    95,
    96,    96,    97,    97,    97,    97,    97,    97,    97,    97,
    97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
    97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
    97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
    97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
    97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
    97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
    97,    97,    97,    97,    97,    97,    97,    97,    97,    97,
    97,    98,    98,    99,    99,   100,   100,   101,   101,   102,
   102,   103,   104,   104,   105,   105,   106,   106,   107,   107,
   108,   108,   109,   109,   109,   110,   110,   111,   111,   112,
   112,   113,   113,   114,   114,   115,   115,   116,   116,   117,
   117,   118,   118,   119,   119,   120,   120,   121,   121,   122,
   122,   123,   123,   124,   124,   125,   125,   126,   126,   127,
   127,   127
};

static const short yyr2[] = {     0,
     0,     2,     1,     2,     2,     2,     1,     2,     1,     2,
     1,     2,     3,     3,     3,     3,     2,     3,     1,     1,
     2,     1,     1,     1,     0,     2,     2,     4,     4,     1,
     1,     1,     2,     1,     1,     3,     1,     3,     1,     1,
     3,     3,     1,     3,     1,     3,     1,     3,     1,     3,
     1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     2,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     2,     2,     2,     2,    14,     2,     6,     2,     4,
     2,     4,     4,     2,     2,     2,     4,     2,     4,     2,
     2,     2,     2,     4,     2,     4,     2,     2,     2,     6,
     2,     2,     2,     2,     2,     4,     2,     8,     2,    12,
     2,     4,     2,     8,     2,     2,     2,     1,     3,     8,
     2,     6,     2,    18,     2,     4,     2,     8,     2,     6,
     4,     3
};

static const short yydefact[] = {     1,
     0,     0,     0,     0,     3,     0,     9,    34,    25,    32,
     2,     0,     7,     0,    30,    35,    31,     8,     0,     5,
     0,     6,    25,    19,    20,    23,    24,     0,    22,    17,
     0,     0,     4,    10,    25,    33,     0,     0,     0,    16,
    27,    26,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    21,    18,    36,    11,     0,    13,    14,    15,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   117,     0,     0,     0,     0,
     0,     0,     0,    12,    28,    29,     0,    51,     0,     0,
    53,    54,     0,     0,    55,    56,     0,     0,    79,    80,
     0,    37,     0,    81,    82,    61,    62,     0,     0,   101,
   102,    73,    74,     0,     0,   105,   106,     0,     0,    97,
    98,     0,     0,    63,    64,     0,     0,    95,    96,     0,
     0,   107,   108,     0,     0,   113,   114,     0,    39,    40,
     0,   103,   104,    57,    58,    59,    60,    65,    66,    67,
    68,    69,    70,     0,     0,    71,    72,     0,     0,    75,
    76,     0,    77,    78,     0,     0,    83,    84,     0,     0,
    85,    86,     0,     0,    87,    88,     0,     0,    89,    90,
     0,     0,    91,    92,     0,    49,     0,    93,    94,     0,
     0,    99,   100,     0,     0,   109,   110,     0,     0,   111,
   112,   115,   116,     0,   178,   118,     0,   119,     0,     0,
   120,   121,     0,     0,   122,   123,   124,   125,     0,     0,
   126,   127,   128,   129,   131,   130,   133,     0,     0,     0,
   132,   135,   134,   144,     0,   146,     0,   145,   163,   162,
   167,     0,   189,     0,   137,     0,   185,     0,   169,     0,
   175,     0,   165,     0,     0,   164,   139,     0,   141,     0,
     0,   148,     0,   150,     0,   152,   151,   155,     0,   153,
   157,     0,   159,     0,   158,   161,     0,   171,     0,   173,
     0,   177,     0,   176,   181,     0,   183,     0,   187,     0,
   192,     0,    52,     0,    38,    43,     0,     0,     0,     0,
     0,     0,    42,    41,     0,     0,     0,     0,     0,     0,
     0,    50,     0,     0,     0,   179,     0,     0,    45,     0,
     0,   191,   143,     0,   166,     0,     0,     0,     0,     0,
     0,   140,   142,   147,   149,   154,   156,     0,     0,   172,
     0,     0,     0,   186,    47,     0,    44,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    46,     0,   190,
     0,     0,     0,     0,     0,   138,   160,     0,     0,   182,
    48,     0,     0,     0,     0,     0,     0,     0,   188,     0,
     0,   168,   174,     0,   180,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   170,     0,     0,   136,
     0,     0,     0,     0,   184,     0,     0
};

static const short yydefgoto[] = {     1,
    11,    87,    88,    20,    22,    13,    28,    29,    30,    31,
    32,   144,    15,    16,    17,   153,   191,   347,   370,   396,
   237,   140,    83,   141,   145,   174,   206,   210,   213,   149,
   154,   217,   221,   225,   229,   233,   238,   242,   160,   192,
   166,   182,   246,   250,   186,   256,   257,   261,   265,   178,
   271,   170,   142
};

static const short yypact[] = {-32768,
    22,    32,    36,    44,-32768,    50,-32768,-32768,   290,-32768,
-32768,   -55,-32768,    50,-32768,-32768,    47,-32768,    69,-32768,
   -37,-32768,   222,-32768,-32768,-32768,-32768,    50,-32768,-32768,
    50,   580,-32768,-32768,   222,    71,   -27,   -27,   -52,-32768,
   263,    49,    50,    50,    50,    50,    50,    50,    50,    50,
    50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
    50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
    50,    50,    50,    50,   -27,    50,    50,    50,    50,    50,
   131,    50,-32768,-32768,-32768,-32768,   -23,-32768,-32768,-32768,
    50,    50,   134,    28,   136,   145,    28,   153,    28,    33,
   161,   106,   164,   172,   181,   110,    28,    28,    28,    28,
    28,   186,   190,   -33,   121,   211,   213,   229,   232,   237,
   240,   257,   272,    28,    79,-32768,   306,   308,   164,   124,
   161,    80,    38,-32768,    81,    81,    89,-32768,    25,    48,
-32768,-32768,   101,   -27,-32768,-32768,   116,    50,-32768,-32768,
   140,-32768,   -27,-32768,-32768,-32768,-32768,   144,   -27,-32768,
-32768,-32768,-32768,   151,    50,-32768,-32768,   177,    50,-32768,
-32768,   180,    50,-32768,-32768,   185,    50,-32768,-32768,   187,
    50,-32768,-32768,   191,    50,-32768,-32768,   198,-32768,-32768,
    66,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   200,   -62,-32768,-32768,   202,    50,-32768,
-32768,    50,-32768,-32768,   205,    50,-32768,-32768,   221,    50,
-32768,-32768,   223,   -27,-32768,-32768,   233,   -27,-32768,-32768,
   236,    50,-32768,-32768,   244,-32768,    67,-32768,-32768,   253,
    50,-32768,-32768,   255,    50,-32768,-32768,   258,    50,-32768,
-32768,-32768,-32768,   264,   120,-32768,   -27,-32768,   267,    50,
-32768,-32768,   273,    50,-32768,-32768,-32768,-32768,   278,    50,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   291,   -40,   158,
-32768,-32768,-32768,-32768,    96,-32768,    62,-32768,-32768,-32768,
-32768,    84,-32768,    94,-32768,    96,-32768,   156,-32768,   206,
-32768,   215,-32768,   169,    91,-32768,-32768,   259,-32768,   274,
    96,-32768,    96,-32768,    96,-32768,-32768,-32768,   248,-32768,
-32768,    96,-32768,   296,-32768,-32768,    96,-32768,   310,-32768,
    96,-32768,   280,-32768,-32768,   318,-32768,   324,-32768,   347,
-32768,   -27,-32768,   -27,-32768,-32768,   -27,    50,    50,    50,
    50,    50,-32768,-32768,    50,   -27,   -27,   -27,   -27,   -27,
   -27,-32768,    50,    50,   -27,   120,    50,    50,-32768,   -27,
   316,-32768,-32768,   322,-32768,   349,   351,   354,   364,   366,
   201,-32768,-32768,-32768,-32768,-32768,-32768,    96,   368,-32768,
   374,   381,   328,-32768,-32768,   -27,-32768,    50,    50,    50,
    50,    50,    66,   -27,    50,    50,   -27,-32768,   345,-32768,
   381,   385,   391,    96,   381,-32768,-32768,   393,   381,-32768,
-32768,   -27,    50,    50,   -27,   -27,    50,   -27,-32768,   395,
   397,-32768,-32768,   399,-32768,    50,    50,    50,   401,   403,
    96,    50,    50,   -27,   409,   412,-32768,   -27,    50,-32768,
    96,    50,   381,   -27,-32768,   196,-32768
};

static const short yypgoto[] = {-32768,
-32768,    -1,   128,-32768,-32768,-32768,   313,-32768,   -20,   323,
-32768,     3,   355,   332,   373,-32768,    15,-32768,-32768,  -296,
-32768,  -111,-32768,-32768,   -91,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   279,
-32768,   289,   559
};


#define	YYLAST		692


static const short yytable[] = {    12,
   205,     7,    40,    14,    23,   156,    33,   162,    34,    86,
   280,     7,    35,   255,    84,   194,   196,   198,   200,   202,
    36,   456,     2,    34,   342,   278,    41,     8,   143,    42,
    34,     8,   252,   164,    86,    10,     7,   139,   134,    10,
    34,    93,    94,    95,    96,    97,    98,    99,   100,   101,
   102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,   127,   128,   129,   130,   131,   254,
   133,     3,     4,     5,     6,     7,     8,     9,     7,   135,
   136,    34,     8,    18,    10,   407,    34,     8,   139,    19,
    10,    34,   165,   139,   173,    10,   172,    21,   139,    86,
   188,     7,    34,     7,   422,    24,   212,   216,   426,    36,
   280,   215,   428,   134,   269,    34,   345,    86,    86,     7,
     7,   132,   270,    37,   137,     8,   147,   279,   304,   324,
   134,   275,    34,   138,    34,   151,   285,    34,   346,   139,
   277,   287,   134,   158,    34,   354,   454,    34,   348,    34,
     8,   168,   282,   292,   176,    89,    90,   294,    10,    34,
     8,   296,   180,    34,   189,   298,   139,   284,    10,   300,
   139,   184,   190,   302,    34,     8,   204,    34,     8,   305,
   208,   139,   280,    10,   139,   457,    10,    34,   138,    34,
   148,   286,   126,   308,   139,   289,   139,   310,    34,   152,
   311,   219,   291,   223,   313,   139,    34,   159,   315,    34,
   350,   366,   343,   139,    34,   169,   319,    34,   177,   227,
   322,   139,   231,   353,   139,    34,   181,   235,   293,   327,
   240,   295,   139,   329,    34,   185,   297,   331,   299,    34,
   138,   139,   301,    34,   209,   333,   139,   244,   336,   303,
   139,   307,   338,   309,    34,   189,   312,   281,   340,    34,
   351,   283,   248,   190,    34,   220,    34,   224,    34,   352,
   288,   139,   314,   139,   316,    34,   290,   344,    24,    25,
    26,    27,    34,   228,   318,    34,   232,   321,   349,   139,
    34,   236,   139,    34,   241,   323,   259,   139,   263,   134,
   139,    34,   360,   357,   326,   358,   328,   359,   306,   330,
    34,   245,    34,   355,   361,   332,    34,   139,   335,   363,
    25,    26,    27,   365,   337,    34,   249,    34,   356,   339,
   371,   134,   139,    34,   138,   374,   376,   377,   378,   379,
   380,   317,   341,   381,    92,   320,    24,    25,    26,    27,
   362,   388,   389,    91,   325,   391,   392,    85,   393,    34,
   260,    34,   264,    34,   364,    38,   139,   134,   139,    34,
   395,    34,   367,   134,   334,    34,   397,    34,   368,   134,
   404,    34,   408,    39,   409,   403,   411,   412,   413,   414,
   415,   305,     0,   418,   419,   409,   134,   267,    34,   421,
    34,   369,    34,   398,    34,   399,   425,    34,   400,   273,
   409,   430,   431,     0,   409,   434,   409,    34,   401,    34,
   402,    34,   405,     0,   439,   440,   441,    34,   406,     0,
   445,   446,     0,   444,    34,   395,     0,   451,    34,   423,
   453,     0,   409,   452,    34,   424,    34,   427,    34,   436,
    34,   437,    34,   438,    34,   442,    34,   443,     0,   372,
     0,   373,    34,   448,   375,    34,   449,     0,     0,     0,
     0,     0,     0,   382,   383,   384,   385,   386,   387,     0,
     0,     0,   390,     0,     0,     0,     0,   394,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   410,     0,     0,     0,     0,     0,     0,
   416,   417,     0,     0,   420,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   429,
     0,     0,   432,   433,     0,   435,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   447,     0,     0,     0,   450,     0,     0,     0,     0,
     0,   455,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,     0,    62,    63,    64,    65,    66,    67,    68,    69,
    70,     0,    71,     0,     0,     0,     0,    72,    73,     0,
    74,     0,     0,    75,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    76,    77,    78,    79,    80,     0,
     0,     0,     0,     0,    81,     0,     0,     0,     0,     0,
     0,    82,   146,   150,   155,   157,   161,   163,   167,   171,
   175,   179,   183,   187,   193,   195,   197,   199,   201,   203,
   207,   211,   214,   218,   222,   226,   230,   234,   239,   243,
   247,   251,   253,   258,     0,   262,   266,   268,   272,   274,
     0,   276
};

static const short yycheck[] = {     1,
   112,    64,    23,     1,     6,    97,    62,    99,    64,    62,
    73,    64,    14,   125,    35,   107,   108,   109,   110,   111,
    73,     0,     1,    64,    65,     1,    28,    65,     1,    31,
    64,    65,   124,     1,    62,    73,    64,    71,    62,    73,
    64,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,     1,
    82,    60,    61,    62,    63,    64,    65,    66,    64,    91,
    92,    64,    65,    62,    73,   392,    64,    65,    71,    64,
    73,    64,   100,    71,   102,    73,     1,    64,    71,    62,
     1,    64,    64,    64,   411,    67,   114,   115,   415,    73,
    73,     1,   419,    62,     1,    64,    65,    62,    62,    64,
    64,     1,   130,    65,     1,    65,     1,   139,    73,    73,
    62,    62,    64,    65,    64,     1,   148,    64,    65,    71,
    62,   153,    62,     1,    64,    65,   453,    64,    65,    64,
    65,     1,    62,   165,     1,    38,    39,   169,    73,    64,
    65,   173,     1,    64,    65,   177,    71,    62,    73,   181,
    71,     1,    73,   185,    64,    65,     1,    64,    65,   191,
     1,    71,    73,    73,    71,     0,    73,    64,    65,    64,
    65,    62,    75,   205,    71,    62,    71,   209,    64,    65,
   212,     1,    62,     1,   216,    71,    64,    65,   220,    64,
    65,   333,    65,    71,    64,    65,   228,    64,    65,     1,
   232,    71,     1,    65,    71,    64,    65,     1,    62,   241,
     1,    62,    71,   245,    64,    65,    62,   249,    62,    64,
    65,    71,    62,    64,    65,   257,    71,     1,   260,    62,
    71,    62,   264,    62,    64,    65,    62,   140,   270,    64,
    65,   144,     1,    73,    64,    65,    64,    65,    64,    65,
   153,    71,    62,    71,    62,    64,   159,   285,    67,    68,
    69,    70,    64,    65,    62,    64,    65,    62,   296,    71,
    64,    65,    71,    64,    65,    62,     1,    71,     1,    62,
    71,    64,    65,   311,    62,   313,    62,   315,   191,    62,
    64,    65,    64,    65,   322,    62,    64,    71,    62,   327,
    68,    69,    70,   331,    62,    64,    65,    64,    65,    62,
   342,    62,    71,    64,    65,   347,   348,   349,   350,   351,
   352,   224,    62,   355,    42,   228,    67,    68,    69,    70,
    65,   363,   364,    41,   237,   367,   368,    36,   370,    64,
    65,    64,    65,    64,    65,    21,    71,    62,    71,    64,
    65,    64,    65,    62,   257,    64,    65,    64,    65,    62,
   388,    64,    65,    21,   396,   381,   398,   399,   400,   401,
   402,   403,    -1,   405,   406,   407,    62,   129,    64,    65,
    64,    65,    64,    65,    64,    65,   414,    64,    65,   131,
   422,   423,   424,    -1,   426,   427,   428,    64,    65,    64,
    65,    64,    65,    -1,   436,   437,   438,    64,    65,    -1,
   442,   443,    -1,   441,    64,    65,    -1,   449,    64,    65,
   452,    -1,   454,   451,    64,    65,    64,    65,    64,    65,
    64,    65,    64,    65,    64,    65,    64,    65,    -1,   342,
    -1,   344,    64,    65,   347,    64,    65,    -1,    -1,    -1,
    -1,    -1,    -1,   356,   357,   358,   359,   360,   361,    -1,
    -1,    -1,   365,    -1,    -1,    -1,    -1,   370,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   396,    -1,    -1,    -1,    -1,    -1,    -1,
   403,   404,    -1,    -1,   407,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,
    -1,    -1,   425,   426,    -1,   428,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   444,    -1,    -1,    -1,   448,    -1,    -1,    -1,    -1,
    -1,   454,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    -1,    33,    -1,    -1,    -1,    -1,    38,    39,    -1,
    41,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    55,    56,    57,    58,    59,    -1,
    -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
    -1,    72,    94,    95,    96,    97,    98,    99,   100,   101,
   102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
   112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
   122,   123,   124,   125,    -1,   127,   128,   129,   130,   131,
    -1,   133
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 7:
#line 82 "zparser.y"
{   /* rr should be fully parsed */
	    if (!parser->error_occurred) {
		    if (!parser->current_zone
			&& parser->current_rr.type != TYPE_SOA)
		    {
			    error("RR before SOA skipped");
		    } else {
			    parser->current_rr.zone = parser->current_zone;
			    parser->current_rr.rrdata
				    = (rrdata_type *) region_alloc_init(
					    parser->region,
					    parser->current_rr.rrdata,
					    rrdata_size(parser->current_rr.rrdata->rdata_count));

			    process_rr();
		    }
	    }

	    region_free_all(parser->rr_region);

	    parser->current_rr.type = 0;
	    parser->current_rr.rrdata = parser->temporary_rrdata;
	    parser->current_rr.rrdata->rdata_count = 0;
	    parser->error_occurred = 0;
    ;
    break;}
case 8:
#line 108 "zparser.y"
{
	    error_prev_line("syntax error");
    ;
    break;}
case 13:
#line 123 "zparser.y"
{ 
        if (yyvsp[-1].data.len > MAXDOMAINLEN ) {
            error("$TTL value is too large");
            return 1;
        } 
        /* perform TTL conversion */
        if ( ( parser->default_ttl = zparser_ttl2int(yyvsp[-1].data.str)) == -1 )
            parser->default_ttl = DEFAULT_TTL;
    ;
    break;}
case 14:
#line 135 "zparser.y"
{
        /* [xxx] does $origin not effect previous */
	/* [XXX] label length checks should be in dname functions */

	/* Copy from RR region to zone region.  */
        parser->origin = yyvsp[-1].domain;
    ;
    break;}
case 15:
#line 143 "zparser.y"
{
	    error_prev_line("$ORIGIN directive requires absolute domain name");
    ;
    break;}
case 16:
#line 149 "zparser.y"
{
        parser->current_rr.owner = parser->origin;
        parser->prev_dname = parser->origin;
    ;
    break;}
case 17:
#line 154 "zparser.y"
{
        /* a tab, use previously defined dname */
        parser->current_rr.owner = parser->prev_dname;
        
    ;
    break;}
case 18:
#line 160 "zparser.y"
{
	    /* Copy from RR region to zone region.  */
	    parser->current_rr.owner = yyvsp[-2].domain;

	    /* set this as previous */
	    parser->prev_dname = parser->current_rr.owner;
    ;
    break;}
case 19:
#line 170 "zparser.y"
{
        /* set the ttl */
        if ( (parser->current_rr.rrdata->ttl = 
		zparser_ttl2int(yyvsp[0].data.str) ) == -1) {
	            parser->current_rr.rrdata->ttl = parser->default_ttl;
		    return 0;
	}
    ;
    break;}
case 20:
#line 181 "zparser.y"
{
        /* set the class  (class unknown handled in lexer) */
        parser->current_rr.klass =  parser->default_class;
    ;
    break;}
case 21:
#line 188 "zparser.y"
{
	parser->current_rr.type = yyvsp[0].type;
    ;
    break;}
case 23:
#line 194 "zparser.y"
{ error("CHAOS class not supported"); ;
    break;}
case 24:
#line 195 "zparser.y"
{ error("HESIOD Class not supported"); ;
    break;}
case 25:
#line 199 "zparser.y"
{
        parser->current_rr.rrdata->ttl = parser->default_ttl;
        parser->current_rr.klass = parser->default_class;
    ;
    break;}
case 26:
#line 204 "zparser.y"
{
        parser->current_rr.rrdata->ttl = parser->default_ttl;
    ;
    break;}
case 27:
#line 208 "zparser.y"
{   
        parser->current_rr.klass = parser->default_class;
    ;
    break;}
case 31:
#line 217 "zparser.y"
{
		if (yyvsp[0].dname == error_dname) {
			yyval.domain = error_domain;
		} else if (yyvsp[0].dname->name_size + domain_dname(parser->origin)->name_size - 1 > MAXDOMAINLEN) {
			error("domain name exceeds %d character limit", MAXDOMAINLEN);
			yyval.domain = error_domain;
		} else {
			yyval.domain = domain_table_insert(
				parser->db->domains, 
				cat_dname(parser->rr_region, yyvsp[0].dname, domain_dname(parser->origin)));
		}
    	;
    break;}
case 32:
#line 232 "zparser.y"
{
	    yyval.domain = parser->db->domains->root;
    ;
    break;}
case 33:
#line 236 "zparser.y"
{ 
	    if (yyvsp[-1].dname != error_dname) {
		    yyval.domain = domain_table_insert(parser->db->domains, yyvsp[-1].dname);
	    } else {
		    yyval.domain = error_domain;
	    }
    ;
    break;}
case 34:
#line 246 "zparser.y"
{
	    if (yyvsp[0].data.len > MAXLABELLEN) {
		    error("label exceeds %d character limit", MAXLABELLEN);
		    yyval.dname = error_dname;
	    } else {
		    yyval.dname = create_dname(parser->rr_region, (uint8_t *) yyvsp[0].data.str, yyvsp[0].data.len);
	    }
    ;
    break;}
case 36:
#line 258 "zparser.y"
{
	    if (yyvsp[-2].dname == error_dname || yyvsp[0].dname == error_dname) {
		    yyval.dname = error_dname;
	    } else if (yyvsp[-2].dname->name_size + yyvsp[0].dname->name_size - 1 > MAXDOMAINLEN) {
		    error("domain name exceeds %d character limit", MAXDOMAINLEN);
		    yyval.dname = error_dname;
	    } else {
		    yyval.dname = cat_dname(parser->rr_region, yyvsp[-2].dname, yyvsp[0].dname);
	    }
    ;
    break;}
case 37:
#line 271 "zparser.y"
{
        	zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[0].data.str));
    	;
    break;}
case 38:
#line 275 "zparser.y"
{
        	zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[0].data.str));
    	;
    break;}
case 40:
#line 283 "zparser.y"
{
		yyval.data.len = 1;
		yyval.data.str = region_strdup(parser->rr_region, ".");
	;
    break;}
case 41:
#line 288 "zparser.y"
{
		yyval.data.len = yyvsp[-2].data.len + yyvsp[0].data.len + 1;
		yyval.data.str = (char *) region_alloc(parser->rr_region, yyval.data.len + 1);
		memcpy(yyval.data.str, yyvsp[-2].data.str, yyvsp[-2].data.len);
		memcpy(yyval.data.str + yyvsp[-2].data.len, " ", 1);
		memcpy(yyval.data.str + yyvsp[-2].data.len + 1, yyvsp[0].data.str, yyvsp[0].data.len);
		yyval.data.str[yyval.data.len] = '\0';
	;
    break;}
case 42:
#line 297 "zparser.y"
{
		yyval.data.len = yyvsp[-2].data.len + yyvsp[0].data.len + 1;
		yyval.data.str = (char *) region_alloc(parser->rr_region, yyval.data.len + 1);
		memcpy(yyval.data.str, yyvsp[-2].data.str, yyvsp[-2].data.len);
		memcpy(yyval.data.str + yyvsp[-2].data.len, ".", 1);
		memcpy(yyval.data.str + yyvsp[-2].data.len + 1, yyvsp[0].data.str, yyvsp[0].data.len);
		yyval.data.str[yyval.data.len] = '\0';
	;
    break;}
case 43:
#line 309 "zparser.y"
{
		uint16_t type = lookup_type_by_name(yyvsp[0].data.str);
		if (type != 0 && type < 128) {
			set_bit(nxtbits, type);
		} else {
			error("bad type %d in NXT record", (int) type);
		}
	;
    break;}
case 44:
#line 318 "zparser.y"
{
		uint16_t type = lookup_type_by_name(yyvsp[0].data.str);
		if (type != 0 && type < 128) {
			set_bit(nxtbits, type);
		} else {
			error("bad type %d in NXT record", (int) type);
		}
	;
    break;}
case 45:
#line 329 "zparser.y"
{
		uint16_t type = lookup_type_by_name(yyvsp[0].data.str);
		if (type != 0) {
			set_bitnsec(nsecbits, type);
		} else {
			error("bad type %d in NSEC record", (int) type);
		}
	;
    break;}
case 46:
#line 338 "zparser.y"
{
		uint16_t type = lookup_type_by_name(yyvsp[0].data.str);
		if (type != 0) {
			set_bitnsec(nsecbits, type);
		} else {
			error("bad type %d in NSEC record", (int) type);
		}
	;
    break;}
case 48:
#line 354 "zparser.y"
{
		char *result = (char *) region_alloc(parser->rr_region,
						     yyvsp[-2].data.len + yyvsp[0].data.len + 1);
		memcpy(result, yyvsp[-2].data.str, yyvsp[-2].data.len);
		memcpy(result + yyvsp[-2].data.len, yyvsp[0].data.str, yyvsp[0].data.len);
		yyval.data.str = result;
		yyval.data.len = yyvsp[-2].data.len + yyvsp[0].data.len;
		yyval.data.str[yyval.data.len] = '\0';
	;
    break;}
case 50:
#line 371 "zparser.y"
{
		char *result = (char *) region_alloc(parser->rr_region,
						     yyvsp[-2].data.len + yyvsp[0].data.len + 1);
		memcpy(result, yyvsp[-2].data.str, yyvsp[-2].data.len);
		memcpy(result + yyvsp[-2].data.len, yyvsp[0].data.str, yyvsp[0].data.len);
		yyval.data.str = result;
		yyval.data.len = yyvsp[-2].data.len + yyvsp[0].data.len;
		yyval.data.str[yyval.data.len] = '\0';
	;
    break;}
case 52:
#line 387 "zparser.y"
{
		char *result = (char *) region_alloc(parser->rr_region,
						     yyvsp[-2].data.len + yyvsp[0].data.len + 2);
		memcpy(result, yyvsp[-2].data.str, yyvsp[-2].data.len);
		result[yyvsp[-2].data.len] = '.';
		memcpy(result + yyvsp[-2].data.len + 1, yyvsp[0].data.str, yyvsp[0].data.len);
		yyval.data.str = result;
		yyval.data.len = yyvsp[-2].data.len + yyvsp[0].data.len + 1;
		yyval.data.str[yyval.data.len] = '\0';
	;
    break;}
case 54:
#line 406 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 56:
#line 408 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 57:
#line 409 "zparser.y"
{ warning_prev_line("MD is obsolete"); ;
    break;}
case 58:
#line 411 "zparser.y"
{
	    warning_prev_line("MD is obsolete");
	    yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown);
    ;
    break;}
case 59:
#line 415 "zparser.y"
{ warning_prev_line("MF is obsolete"); ;
    break;}
case 60:
#line 417 "zparser.y"
{
	    warning_prev_line("MF is obsolete");
	    yyval.type = yyvsp[-2].type;
	    parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown);
    ;
    break;}
case 62:
#line 423 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 64:
#line 425 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 65:
#line 426 "zparser.y"
{ warning_prev_line("MB is obsolete"); ;
    break;}
case 66:
#line 428 "zparser.y"
{
	    warning_prev_line("MB is obsolete");
	    yyval.type = yyvsp[-2].type;
	    parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown);
    ;
    break;}
case 68:
#line 434 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 70:
#line 436 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 72:
#line 439 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 74:
#line 441 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 76:
#line 443 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 78:
#line 445 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 80:
#line 447 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 82:
#line 449 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 84:
#line 451 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 86:
#line 453 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 88:
#line 455 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 90:
#line 457 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 92:
#line 459 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 94:
#line 461 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 96:
#line 463 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 98:
#line 465 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 100:
#line 467 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 102:
#line 469 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 104:
#line 471 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 106:
#line 473 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 108:
#line 475 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 110:
#line 477 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 112:
#line 479 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 114:
#line 481 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 116:
#line 483 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 119:
#line 486 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 121:
#line 488 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 123:
#line 490 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 125:
#line 492 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 127:
#line 494 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 129:
#line 496 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 130:
#line 497 "zparser.y"
{ yyval.type = yyvsp[-2].type; parse_unknown_rdata(yyvsp[-2].type, yyvsp[0].unknown); ;
    break;}
case 131:
#line 499 "zparser.y"
{
	    error_prev_line("Unrecognized RR type '%s'", yyvsp[-2].data.str);
    ;
    break;}
case 132:
#line 511 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_a(parser->region, yyvsp[-1].data.str));
	;
    break;}
case 133:
#line 515 "zparser.y"
{ error_prev_line("Syntax error in A record"); ;
    break;}
case 134:
#line 519 "zparser.y"
{
        /* convert a single dname record */
        zadd_rdata_domain(yyvsp[-1].domain);
    ;
    break;}
case 135:
#line 524 "zparser.y"
{ error_prev_line("Syntax error in RDATA (domain name expected)"); ;
    break;}
case 136:
#line 528 "zparser.y"
{
        /* convert the soa data */
        zadd_rdata_domain(yyvsp[-13].domain);	/* prim. ns */
        zadd_rdata_domain(yyvsp[-11].domain);	/* email */
        zadd_rdata_wireformat(zparser_conv_period(parser->region, yyvsp[-9].data.str)); /* serial */
        zadd_rdata_wireformat(zparser_conv_period(parser->region, yyvsp[-7].data.str)); /* refresh */
        zadd_rdata_wireformat(zparser_conv_period(parser->region, yyvsp[-5].data.str)); /* retry */
        zadd_rdata_wireformat(zparser_conv_period(parser->region, yyvsp[-3].data.str)); /* expire */
        zadd_rdata_wireformat(zparser_conv_period(parser->region, yyvsp[-1].data.str)); /* minimum */

        /* [XXX] also store the minium in case of no TTL? */
        if ( (parser->default_minimum = zparser_ttl2int(yyvsp[-3].data.str) ) == -1 )
            parser->default_minimum = DEFAULT_TTL;
    ;
    break;}
case 137:
#line 543 "zparser.y"
{ error_prev_line("Syntax error in SOA record"); ;
    break;}
case 138:
#line 547 "zparser.y"
{
		uint16_t *proto_rdata;
		
        	zadd_rdata_wireformat(zparser_conv_a(parser->region, yyvsp[-5].data.str)); /* address */
		proto_rdata = zparser_conv_protocol(parser->region, yyvsp[-3].data.str);
        	zadd_rdata_wireformat(proto_rdata); /* protocol */

		if (proto_rdata) {
			zadd_rdata_wireformat(zparser_conv_services(parser->region, yyvsp[-3].data.str, yyvsp[-1].data.str)); /* services */
		}
	;
    break;}
case 139:
#line 559 "zparser.y"
{ error_prev_line("Syntax error in WKS record"); ;
    break;}
case 140:
#line 563 "zparser.y"
{
        	zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[-3].data.str)); /* CPU */
        	zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[-1].data.str)); /* OS*/
	;
    break;}
case 141:
#line 568 "zparser.y"
{ error_prev_line("Syntax error in HINFO record"); ;
    break;}
case 142:
#line 572 "zparser.y"
{
        /* convert a single dname record */
        zadd_rdata_domain(yyvsp[-3].domain);
        zadd_rdata_domain(yyvsp[-1].domain);
    ;
    break;}
case 143:
#line 580 "zparser.y"
{
        	zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-3].data.str));  /* priority */
        	zadd_rdata_domain(yyvsp[-1].domain);  /* MX host */
    	;
    break;}
case 144:
#line 585 "zparser.y"
{ error_prev_line("Syntax error in MX record"); ;
    break;}
case 145:
#line 588 "zparser.y"
{;
    break;}
case 146:
#line 590 "zparser.y"
{ error_prev_line("Syntax error in TXT record"); ;
    break;}
case 147:
#line 595 "zparser.y"
{
		zadd_rdata_domain(yyvsp[-3].domain); /* mbox d-name */
		zadd_rdata_domain(yyvsp[-1].domain); /* txt d-name */
	;
    break;}
case 148:
#line 600 "zparser.y"
{ error_prev_line("Syntax error in RP record"); ;
    break;}
case 149:
#line 605 "zparser.y"
{
               zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-3].data.str)); /* subtype */
               zadd_rdata_domain(yyvsp[-1].domain); /* domain name */
       ;
    break;}
case 150:
#line 610 "zparser.y"
{ error_prev_line("Syntax error in AFSDB record"); ;
    break;}
case 151:
#line 615 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[-1].data.str)); /* X.25 address. */
	;
    break;}
case 152:
#line 619 "zparser.y"
{ error_prev_line("Syntax error in X25 record"); ;
    break;}
case 153:
#line 624 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[-1].data.str)); /* address */
	;
    break;}
case 154:
#line 628 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[-3].data.str)); /* address */
		zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[-1].data.str)); /* sub-address */
	;
    break;}
case 155:
#line 633 "zparser.y"
{ error_prev_line("Syntax error in ISDN record"); ;
    break;}
case 156:
#line 638 "zparser.y"
{
               zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-3].data.str)); /* preference */
               zadd_rdata_domain(yyvsp[-1].domain); /* intermediate host */
	;
    break;}
case 157:
#line 643 "zparser.y"
{ error_prev_line("Syntax error in RT record"); ;
    break;}
case 158:
#line 648 "zparser.y"
{
		/* String must start with "0x" or "0X".  */
		if (strncasecmp(yyvsp[-1].data.str, "0x", 2) != 0) {
			error_prev_line("");
		} else {
			zadd_rdata_wireformat(zparser_conv_hex(parser->region, yyvsp[-1].data.str + 2)); /* NSAP */
		}
	;
    break;}
case 159:
#line 657 "zparser.y"
{ error_prev_line("Syntax error in DS record"); ;
    break;}
case 160:
#line 662 "zparser.y"
{
               zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-5].data.str)); /* preference */
	       zadd_rdata_domain(yyvsp[-3].domain); /* MAP822 */
	       zadd_rdata_domain(yyvsp[-1].domain); /* MAPX400 */
	;
    break;}
case 161:
#line 668 "zparser.y"
{ error_prev_line("Syntax error in PX record"); ;
    break;}
case 162:
#line 672 "zparser.y"
{
        	zadd_rdata_wireformat(zparser_conv_a6(parser->region, yyvsp[-1].data.str));  /* IPv6 address */
    	;
    break;}
case 163:
#line 676 "zparser.y"
{ error_prev_line("Syntax error in AAAA record"); ;
    break;}
case 164:
#line 680 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_loc(parser->region, yyvsp[-1].data.str)); /* Location */
	;
    break;}
case 165:
#line 684 "zparser.y"
{ error_prev_line("Syntax error in LOC record"); ;
    break;}
case 166:
#line 688 "zparser.y"
{
		zadd_rdata_domain(yyvsp[-3].domain); /* nxt name */
		zadd_rdata_wireformat(zparser_conv_nxt(parser->region, nxtbits)); /* nxt bitlist */
		memset(nxtbits, 0, sizeof(nxtbits));
	;
    break;}
case 167:
#line 694 "zparser.y"
{ error_prev_line("Syntax error in NXT record"); ;
    break;}
case 168:
#line 698 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-7].data.str)); /* prio */
		zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-5].data.str)); /* weight */
		zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-3].data.str)); /* port */
		zadd_rdata_domain(yyvsp[-1].domain); /* target name */
	;
    break;}
case 169:
#line 705 "zparser.y"
{ error_prev_line("Syntax error in SRV record"); ;
    break;}
case 170:
#line 710 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-11].data.str)); /* order */
		zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-9].data.str)); /* preference */
		zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[-7].data.str)); /* flags */
		zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[-5].data.str)); /* service */
		zadd_rdata_wireformat(zparser_conv_text(parser->region, yyvsp[-3].data.str)); /* regexp */
		zadd_rdata_domain(yyvsp[-1].domain); /* target name */
	;
    break;}
case 171:
#line 719 "zparser.y"
{ error_prev_line("Syntax error in NAPTR record"); ;
    break;}
case 172:
#line 724 "zparser.y"
{
               zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-3].data.str)); /* preference */
	       zadd_rdata_domain(yyvsp[-1].domain); /* exchanger */
	;
    break;}
case 173:
#line 729 "zparser.y"
{ error_prev_line("Syntax error in KX record"); ;
    break;}
case 174:
#line 734 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_certificate_type(parser->region, yyvsp[-7].data.str)); /* type */
		zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-5].data.str)); /* key tag */
		zadd_rdata_wireformat(zparser_conv_algorithm(parser->region, yyvsp[-3].data.str)); /* algorithm */
		zadd_rdata_wireformat(zparser_conv_b64(parser->region, yyvsp[-1].data.str)); /* certificate or CRL */
	;
    break;}
case 175:
#line 741 "zparser.y"
{ error_prev_line("Syntax error in CERT record"); ;
    break;}
case 177:
#line 747 "zparser.y"
{ error_prev_line("Syntax error in APL record"); ;
    break;}
case 178:
#line 751 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_apl_rdata(parser->region, yyvsp[0].data.str));
	;
    break;}
case 179:
#line 755 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_apl_rdata(parser->region, yyvsp[0].data.str));
	;
    break;}
case 180:
#line 761 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-7].data.str)); /* keytag */
		zadd_rdata_wireformat(zparser_conv_byte(parser->region, yyvsp[-5].data.str)); /* alg */
		zadd_rdata_wireformat(zparser_conv_byte(parser->region, yyvsp[-3].data.str)); /* type */
		zadd_rdata_wireformat(zparser_conv_hex(parser->region, yyvsp[-1].data.str)); /* hash */
	;
    break;}
case 181:
#line 768 "zparser.y"
{ error_prev_line("Syntax error in DS record"); ;
    break;}
case 182:
#line 772 "zparser.y"
{
               zadd_rdata_wireformat(zparser_conv_byte(parser->region, yyvsp[-5].data.str)); /* alg */
               zadd_rdata_wireformat(zparser_conv_byte(parser->region, yyvsp[-3].data.str)); /* fp type */
               zadd_rdata_wireformat(zparser_conv_hex(parser->region, yyvsp[-1].data.str)); /* hash */
       ;
    break;}
case 183:
#line 778 "zparser.y"
{ error_prev_line("Syntax error in SSHFP record"); ;
    break;}
case 184:
#line 782 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_rrtype(parser->region, yyvsp[-17].data.str)); /* rr covered */
		zadd_rdata_wireformat(zparser_conv_byte(parser->region, yyvsp[-15].data.str)); /* alg */
		zadd_rdata_wireformat(zparser_conv_byte(parser->region, yyvsp[-13].data.str)); /* # labels */
		zadd_rdata_wireformat(zparser_conv_period(parser->region, yyvsp[-11].data.str)); /* # orig TTL */
		zadd_rdata_wireformat(zparser_conv_time(parser->region, yyvsp[-9].data.str)); /* sig exp */
		zadd_rdata_wireformat(zparser_conv_time(parser->region, yyvsp[-7].data.str)); /* sig inc */
		zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-5].data.str)); /* key id */
		zadd_rdata_domain(yyvsp[-3].domain); /* signer name */
		zadd_rdata_wireformat(zparser_conv_b64(parser->region, yyvsp[-1].data.str)); /* sig data */
	;
    break;}
case 185:
#line 794 "zparser.y"
{ error_prev_line("Syntax error in RRSIG record"); ;
    break;}
case 186:
#line 798 "zparser.y"
{
		zadd_rdata_domain(yyvsp[-3].domain); /* nsec name */
		zadd_rdata_wireformat(zparser_conv_nsec(parser->region, nsecbits)); /* nsec bitlist */
		memset(nsecbits, 0, sizeof(nsecbits));
	;
    break;}
case 187:
#line 804 "zparser.y"
{ error_prev_line("Syntax error in NSEC record"); ;
    break;}
case 188:
#line 809 "zparser.y"
{
		zadd_rdata_wireformat(zparser_conv_short(parser->region, yyvsp[-7].data.str)); /* flags */
		zadd_rdata_wireformat(zparser_conv_byte(parser->region, yyvsp[-5].data.str)); /* proto */
		zadd_rdata_wireformat(zparser_conv_algorithm(parser->region, yyvsp[-3].data.str)); /* alg */
		zadd_rdata_wireformat(zparser_conv_b64(parser->region, yyvsp[-1].data.str)); /* hash */
	;
    break;}
case 189:
#line 816 "zparser.y"
{ error_prev_line("Syntax error in DNSKEY record"); ;
    break;}
case 190:
#line 820 "zparser.y"
{
		/* $2 is the number of octects, currently ignored */
		yyval.unknown = zparser_conv_hex(parser->region, yyvsp[-1].data.str);

	;
    break;}
case 191:
#line 826 "zparser.y"
{	
		yyval.unknown = zparser_conv_hex(parser->region, "");
	;
    break;}
case 192:
#line 830 "zparser.y"
{
		error_prev_line("Syntax error in UNKNOWN RR rdata");
		yyval.unknown = NULL;
	;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 835 "zparser.y"


int
yywrap(void)
{
    return 1;
}

/*
 * Create the parser.
 */
zparser_type *
zparser_create(region_type *region, region_type *rr_region, namedb_type *db)
{
	zparser_type *result;
	
	result = (zparser_type *) region_alloc(region, sizeof(zparser_type));
	result->region = region;
	result->rr_region = rr_region;
	result->db = db;
	
	result->temporary_rrdata = (rrdata_type *) region_alloc(
		result->region, rrdata_size(MAXRDATALEN));
	
	return result;
}

/*
 * Initialize the parser for a new zone file.
 */
void
zparser_init(const char *filename, uint32_t ttl, uint16_t klass,
	     const char *origin)
{
	memset(nxtbits, 0, sizeof(nxtbits));
	memset(nsecbits, 0, sizeof(nsecbits));

	parser->default_ttl = ttl;
	parser->default_minimum = 0;
	parser->default_class = klass;
	parser->current_zone = NULL;
	parser->origin = domain_table_insert(
		parser->db->domains,
		dname_parse(parser->db->region, origin, NULL)); 
	parser->prev_dname = parser->origin;
	parser->error_occurred = 0;
	parser->errors = 0;
	parser->line = 1;
	parser->filename = filename;
	parser->current_rr.rrdata = parser->temporary_rrdata;
	parser->current_rr.rrdata->rdata_count = 0;
}

int
yyerror(const char *message ATTR_UNUSED)
{
	/* don't do anything with this */
	return 0;
}

static void
error_va_list(const char *fmt, va_list args)
{
	fprintf(stderr, " ERR: Line %u in %s: ", parser->line,
		parser->filename);
	vfprintf(stderr, fmt, args);
	fprintf(stderr, "\n");
	++parser->errors;
	parser->error_occurred = 1;
}

/* the line counting sux, to say the least 
 * with this grose hack we try do give sane
 * numbers back */
void
error_prev_line(const char *fmt, ...) 
{
	va_list args;
	va_start(args, fmt);

	--parser->line;
	error_va_list(fmt, args);
	++parser->line;

	va_end(args);
}

void
error(const char *fmt, ...)
{
	/* send an error message to stderr */
	va_list args;
	va_start(args, fmt);

	error_va_list(fmt, args);

	va_end(args);
}

static void
warning_va_list(const char *fmt, va_list args)
{
	fprintf(stderr, "WARN: Line %u in %s: ", parser->line,
		parser->filename);
	vfprintf(stderr, fmt, args);
	fprintf(stderr, "\n");
}

void
warning_prev_line(const char *fmt, ...) 
{
	va_list args;
	va_start(args, fmt);

	--parser->line;
	warning_va_list(fmt, args);
	++parser->line;

	va_end(args);
}

void 
warning(const char *fmt, ... )
{
	va_list args;

	va_start(args, fmt);
	
	warning_va_list(fmt, args);

	va_end(args);
}
